#include "ledDrive.h"
#include <asm/io.h>

void ledDrive(LedCont *cont,LedBuf *buf)
{
  int x,y,d;
  int dv;      /* ǡݡȤ˽Ϥ */
  int cv;      /* ȥݡȤ˽Ϥ */

  dv = 0;
  cv = 0;

  if(ioperm(cont->portAdr, PORTSIZE, 1)){
    perror("ioperm");
    exit(1);
  }
  
  outb(dv, cont->portAdr);        
  
  for(y=0;y<buf->height;y++){
    for(x=0;x<buf->width;x++){
      d = buf->data[x+y*buf->width];
      if(d & buf->redMask)
	dv |= LED_RED_MASK;
      else
	dv &= ~LED_RED_MASK;
      
      if(d & buf->greenMask)
	dv |= LED_GREEN_MASK;
      else
	dv &= ~LED_GREEN_MASK;
	
      outb(dv, cont->portAdr);
      cv &= ~LED_STB_MASK;
      outb(cv, cont->portAdr+2);
      cv |= LED_STB_MASK;
      outb(cv, cont->portAdr+2);
    }
    outb(dv, cont->portAdr);
    dv |= LED_LATCH_MASK;
    outb(dv, cont->portAdr);
    dv &= ~LED_LATCH_MASK;
    outb(dv, cont->portAdr);
    dv &= ~(LED_RA_MASK << LED_RA_SHIFT);
    dv |= (y & LED_RA_MASK) << LED_RA_SHIFT;
    
    dv &= ~LED_NENABLE_MASK;
    outb(dv, cont->portAdr);

    for(x=0;x<cont->lineDelay;x++)
      outb(dv, cont->portAdr);

    dv |= LED_NENABLE_MASK;
    outb(dv, cont->portAdr);
  }
  if(ioperm(cont->portAdr, PORTSIZE, 0)){
    perror("ioperm");
    exit(1);
  }
}
