#include "ledDrive.h"

void ledErrorExit(char *fmt, ...)
{
  va_list ap;

  va_start(ap, fmt);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(1);
}

void *ledMalloc(size_t size)
{
  void *block;

  block = malloc(size);
  if(block == NULL){
    fprintf(stderr,"Memory allocation error, size=%lu\n",size);
    exit(1);
  }
  memset(block, 0, size);
  return block;
}

void ledFree(void *block)
{
  free(block);
}
