#include "ledDrive.h"

int main(int argc,char *argv[])
{
  int i;
  FILE *ifp;
  LedCont *cont = ledContNew();
  
  if(argc < 2)
    ledErrorExit("Usage:%s command_file|-",argv[0]);

  for(i=1;i<argc;i++){
    if(strcmp(argv[i],"-")==0)
      ledParseCommandFile(cont,stdin);
    else if(strcmp(argv[i],"-d")==0){
      if(i+1 < argc && sscanf(argv[i+1],"%d",&cont->lineDelay) == 1){
	i++;
      }
      else ledErrorExit("Bad Num: -d num");
    }
    else {
      ifp = fopen(argv[i],"r");
      if(ifp == NULL)
	ledErrorExit("%s not found.",argv[i]);
      else{
	ledParseCommandFile(cont, ifp);
	fclose(ifp);
      }
    }
  }
  return 0;
}

LedCont *ledContNew()
{
  LedCont *cont = (LedCont *)ledMalloc(sizeof(LedCont));
  LedBuf  *buf  = (LedBuf  *)ledMalloc(sizeof(LedBuf));

  cont->portAdr   = BASEPORT;
  cont->lineDelay = 512;
  cont->buf = buf;

  buf->width  = 32;
  buf->height = 16;
  buf->redMask = 1;
  buf->greenMask = 2;
  buf->data = ledMalloc( buf->width * buf->height);
  return cont;
}
